#include "spidma.h"

//sck   PA5 ʱź
//miso  PA6 룬
//mosi  PA7 
//SPI1  APB2(72M)ʱӼ72M
void SPI1_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure={0};
    SPI_InitTypeDef  SPI_InitStructure={0};

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA, ENABLE );
    RCC_APB2PeriphClockCmd( RCC_APB2Periph_SPI1,  ENABLE );

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;                     //
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_SetBits(GPIOA,GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7);

    SPI_StructInit(&SPI_InitStructure);                                         //ָĬֵ
    SPI_InitStructure.SPI_Direction         = SPI_Direction_2Lines_FullDuplex;  //SPI˫ģʽ:SPIΪ˫˫ȫ˫
    SPI_InitStructure.SPI_Mode              = SPI_Mode_Master;                  //SPIģʽ:ΪSPI
    SPI_InitStructure.SPI_DataSize          = SPI_DataSize_8b;                  //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_CPOL              = SPI_CPOL_High;                    //ͬʱӵĿ״̬Ϊߵƽ
    SPI_InitStructure.SPI_CPHA              = SPI_CPHA_2Edge;                   //ͬʱӵĵڶأ½ݱ
    SPI_InitStructure.SPI_NSS               = SPI_NSS_Soft;                     //NSSźӲNSSܽţʹSSIλ:ڲNSSźSSIλ
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;          //岨ԤƵֵ:ԤƵֵΪ256   APB2/x
    SPI_InitStructure.SPI_FirstBit          = SPI_FirstBit_MSB;                 //ָݴMSBλLSBλʼ:ݴMSBλʼ
    SPI_InitStructure.SPI_CRCPolynomial     = 7;                                //CRCֵĶʽ
    SPI_Init(SPI1, &SPI_InitStructure);                                         //ʼSPIxĴ

    SPI_Cmd(SPI1, ENABLE);                                                    //ʹSPI
    SPI1_ReadWriteByte(0xff);                                                 //
//    SPI1_SetSpeed(SPI_BaudRatePrescaler_4);                                   //岨ԤƵ

#if DMAx_SPI1==1
    DMAx_SPI1_Init();
#endif
}


//SPI ٶú  SPI1 APB2(72M)ʱӼ72M
//#define SPI_BaudRatePrescaler_2
//#define SPI_BaudRatePrescaler_4
//#define SPI_BaudRatePrescaler_8
//#define SPI_BaudRatePrescaler_16
//#define SPI_BaudRatePrescaler_32
//#define SPI_BaudRatePrescaler_64
//#define SPI_BaudRatePrescaler_128
//#define SPI_BaudRatePrescaler_256
void SPI1_SetSpeed(u8 SPI_BaudRatePrescaler)
{
    SPI1->CTLR1&=0XFFC7;
    SPI1->CTLR1|=SPI_BaudRatePrescaler;   //SPI1ٶ
    SPI_Cmd(SPI1,ENABLE);
}


//SPIx дһֽ
//TxData:Ҫдֽ
//ֵ:ȡֽ
u8 SPI1_ReadWriteByte(u8 TxData)
{
    u8 retry=0;
    while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET) //ָSPI־λ:ͻձ־λ
    {
        retry++;
        if(retry>200)return 0;
    }
    SPI_I2S_SendData(SPI1, TxData); //ͨSPIxһ
    retry=0;

    while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET)//ָSPI־λ:ܻǿձ־λ
    {
        retry++;
        if(retry>200)return 0;
    }
    return SPI_I2S_ReceiveData(SPI1); //ͨSPIxյ
}


#if DMAx_SPI1==1
u8 DMAx_SPI1_Init(void)
{
    DMA_InitTypeDef DMA1_Init={0};

    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1,ENABLE);

    //DMA_SPI_RX  SPI->RAMݴ
    DMA_DeInit(DMA1_Channel2);
    DMA1_Init.DMA_PeripheralBaseAddr=(u32)&SPI1->DATAR;//ǰװʵRAMַ
    DMA1_Init.DMA_DIR=DMA_DIR_PeripheralSRC;
    DMA1_Init.DMA_BufferSize=512;
    DMA1_Init.DMA_PeripheralInc=DMA_PeripheralInc_Disable;
    DMA1_Init.DMA_MemoryInc=DMA_MemoryInc_Enable;
    DMA1_Init.DMA_PeripheralDataSize=DMA_PeripheralDataSize_Byte;
    DMA1_Init.DMA_MemoryDataSize=DMA_MemoryDataSize_Byte;
    DMA1_Init.DMA_Mode=DMA_Mode_Normal;
    DMA1_Init.DMA_Priority=DMA_Priority_High;
    DMA1_Init.DMA_M2M=DMA_M2M_Disable;
    DMA_Init(DMA1_Channel2,&DMA1_Init); //DMAͨ2гʼ

    //DMA_SPI_TX  RAM->SPIݴ
    DMA_DeInit(DMA1_Channel3);
    DMA1_Init.DMA_PeripheralBaseAddr=(u32)&SPI1->DATAR;//ǰװʵRAMַ
    DMA1_Init.DMA_DIR=DMA_DIR_PeripheralDST;
    DMA1_Init.DMA_BufferSize=512;
    DMA1_Init.DMA_PeripheralInc=DMA_PeripheralInc_Disable;
    DMA1_Init.DMA_MemoryInc=DMA_MemoryInc_Enable;
    DMA1_Init.DMA_PeripheralDataSize=DMA_PeripheralDataSize_Byte;
    DMA1_Init.DMA_MemoryDataSize=DMA_MemoryDataSize_Byte;
    DMA1_Init.DMA_Mode=DMA_Mode_Normal;
    DMA1_Init.DMA_Priority=DMA_Priority_High;
    DMA1_Init.DMA_M2M=DMA_M2M_Disable;
    DMA_Init(DMA1_Channel3,&DMA1_Init); //DMAͨ3гʼ

    DMA_ClearFlag(DMA1_FLAG_TC2);
    DMA_ClearFlag(DMA1_FLAG_TC3);               //DMAͨ23Ĵɱ־

    DMA_Cmd(DMA1_Channel2,DISABLE);
    DMA_Cmd(DMA1_Channel3,DISABLE);             //ʹDMAͨ23ֹͣ

    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Rx,DISABLE); //ʹSPIDMA
    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Tx,DISABLE); //ʹSPIDMA

    return 0;
}

//sdȡһݰʱDMA
//buf:ݻ
//len:Ҫȡݳ.
u8 DMAx_SPI1_RX(u8 *buffer,u32 len)
{
    u8 temp=0xff;

    DMA_Cmd(DMA1_Channel2,DISABLE);
    DMA_Cmd(DMA1_Channel3,DISABLE);             //ʹDMAͨ23ֹͣ

    DMA1_Channel2->CNTR=len;                    //ôݳ
    DMA1_Channel2->MADDR=(uint32_t)buffer;      //ڴ滺ַ
    DMA1_Channel2->CFGR|=DMA_MemoryInc_Enable;  //DMAͨ2ָΪڴַʽ

    /*SPIΪݽʱҪʱӣ˴˴DMAͨ3*/
    DMA1_Channel3->CNTR=len;
    DMA1_Channel3->MADDR=(uint32_t)&temp;       //temp=0xff
    DMA1_Channel3->CFGR&=~DMA_MemoryInc_Enable; //ڴַ

    DMA_Cmd(DMA1_Channel2,ENABLE);              //DMAͨ2
    DMA_Cmd(DMA1_Channel3,ENABLE);              //DMAͨ3

    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Rx,ENABLE); //ʹSPIDMA
    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Tx,ENABLE); //ʹSPIDMA

    while(!DMA_GetFlagStatus(DMA1_FLAG_TC2));   //ȴDMAͨ2

    DMA_ClearFlag(DMA1_FLAG_TC2);
    DMA_ClearFlag(DMA1_FLAG_TC3);               //DMAͨ23Ĵɱ־

    DMA_Cmd(DMA1_Channel2,DISABLE);
    DMA_Cmd(DMA1_Channel3,DISABLE);             //ʹDMAͨ23ֹͣ

    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Rx,DISABLE); //ʹSPIDMA
    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Tx,DISABLE); //ʹSPIDMA

    DMA1_Channel3->CFGR|=DMA_MemoryInc_Enable;  //DMAͨ3ָΪڴַʽ
    return 0;
}

//sdдһݰ 512ֽ DMA
//buf:ݻ
u8 DMAx_SPI1_TX(u8 *buffer,u32 len)
{
    u8 temp=0xff;

    DMA_Cmd(DMA1_Channel2,DISABLE);
    DMA_Cmd(DMA1_Channel3,DISABLE);             //ʹDMAͨ23ֹͣ

    DMA1_Channel2->CNTR=len;                    //ôݳ
    DMA1_Channel2->MADDR=(uint32_t)&temp;       //temp=0xff
    DMA1_Channel2->CFGR&=~DMA_MemoryInc_Enable; //ڴַ

    /*SPIΪݽʱҪʱӣ˴˴DMAͨ3*/
    DMA1_Channel3->CNTR=len;
    DMA1_Channel3->MADDR=(uint32_t)buffer;      //ڴ滺ַ
    DMA1_Channel3->CFGR|=DMA_MemoryInc_Enable;  //ڴַ

    DMA_Cmd(DMA1_Channel2,ENABLE);              //DMAͨ2
    DMA_Cmd(DMA1_Channel3,ENABLE);              //DMAͨ3

    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Rx,ENABLE); //ʹSPIDMA
    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Tx,ENABLE); //ʹSPIDMA

    while(!DMA_GetFlagStatus(DMA1_FLAG_TC2));   //ȴDMAͨ2

    DMA_ClearFlag(DMA1_FLAG_TC2);
    DMA_ClearFlag(DMA1_FLAG_TC3);               //DMAͨ23Ĵɱ־

    DMA_Cmd(DMA1_Channel2,DISABLE);
    DMA_Cmd(DMA1_Channel3,DISABLE);             //ʹDMAͨ23ֹͣ

    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Rx,DISABLE); //ʹSPIDMA
    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Tx,DISABLE); //ʹSPIDMA

    DMA1_Channel2->CFGR|=DMA_MemoryInc_Enable;  //DMAͨ3ָΪڴַʽ

    return 0;
}
#endif


